; Quick Saver for Opera9. Ver 1.9.3 by A.Ruzanov
; 11.02.2007



#NoTrayIcon

If WinExists(@ScriptName) Then Exit
AutoItWinSetTitle(@ScriptName)

;  Quick Saver
If @OSLang = 0419 Then
	$Tips = "     "
Else
	$Tips = "Select a folder for quick saving in the list below, then click OK."
EndIf

If $CmdLine[0] = 0 Then
	$QuickSaveDir = FileSelectFolder($Tips, "")
	If Not @error Then IniWrite(@ScriptDir & "\QSaver.ini", "MAIN", "QuickSaveDir", $QuickSaveDir)
	Exit
EndIf

AutoItSetOption("WinTitleMatchMode", 2)
$OperaTitle = WinGetTitle(" - Opera")

AutoItSetOption("WinTitleMatchMode", 4)

$QuickSaveDir = IniRead(@ScriptDir & "\QSaver.ini", "MAIN", "QuickSaveDir", @MyDocumentsDir & "\Web")
$Title = "active"

$QuickSaveDir = StringReplace($QuickSaveDir, "%operadir%", @ScriptDir)
$QuickSaveDir = StringReplace($QuickSaveDir, "%TEMP%", @TempDir)
$QuickSaveDir = StringReplace($QuickSaveDir, "%windir%", @WindowsDir)
$QuickSaveDir = StringReplace($QuickSaveDir, "%ProgramFiles%", @ProgramFilesDir)
$QuickSaveDir = StringReplace($QuickSaveDir, "%DesktopDir%", @DesktopDir)
$QuickSaveDir = StringReplace($QuickSaveDir, "%MyDocuments%", @MyDocumentsDir)
If StringRight($QuickSaveDir, 1) <> "\" Then $QuickSaveDir = $QuickSaveDir & "\"

If $CmdLine[0] > 0 Then
	$Format = $CmdLine[1] - 1
Else
	$Format = 2
EndIf

;   
WinWaitActive($Title, "", 5)

;    
$Title = WinGetTitle($Title, "")

;          
While WinWaitActive($Title, "", 5) = 1
	Sleep(50)
	If @OSTYPE = "WIN32_WINDOWS" Then
		ControlCommand($Title, "", "ComboBox2", "SetCurrentSelection", 0)
		ControlCommand($Title, "", "ComboBox2", "SetCurrentSelection", 0)
		ControlCommand($Title, "", "ComboBox2", "SetCurrentSelection", $Format)
		ControlCommand($Title, "", "ComboBox2", "SetCurrentSelection", $Format)
	Else
		ControlCommand($Title, "", "ComboBox3", "SetCurrentSelection", 0)
		ControlCommand($Title, "", "ComboBox3", "SetCurrentSelection", 0)
		ControlCommand($Title, "", "ComboBox3", "SetCurrentSelection", $Format)
		ControlCommand($Title, "", "ComboBox3", "SetCurrentSelection", $Format)
	EndIf
	
	If $CmdLine[0] > 1 And $CmdLine[2] = 0 Then
		Exit
	Else
		ControlDisable($Title, "", "SysListView321")
		$text = ControlGetText($Title, "", "Edit1")
		$result = StringInStr($text, ".", 0, -1)
		$Name = StringLeft($text, $result - 1)
		$Ext = StringMid($text, $result)
		If $Ext <> ".mht" And $Ext <> ".htm" And $Ext <> ".html" And $Ext <> ".shtml" And $Ext <> ".dhtml" And $Ext <> ".mhtml" And $Ext <> ".php" And $Ext <> ".txt" Then $Ext = ".htm"
		If $CmdLine[0] > 2 And $CmdLine[3] <> '"' Then
			$Name = CorrectName($CmdLine[3])
		Else
			If StringLen($Name) = 0 Then $Name = StringReplace($OperaTitle, " - Opera", "")
			$Name = CorrectName($Name)
		EndIf
		
		If $CmdLine[0] > 1 And $CmdLine[2] = 2 Then $QuickSaveDir = $QuickSaveDir & StringLeft(StringReplace($Name, " ", "_"), 64) & "\"
		If FileExists($QuickSaveDir & $Name & $Ext) Then
			$Num = 1
			While FileExists($QuickSaveDir & $Name & "_" & $Num & $Ext)
				$Num = $Num + 1
			WEnd
			$Name = $Name & "_" & $Num
		EndIf
		ControlSetText($Title, "", "Edit1", $QuickSaveDir & $Name & $Ext)
		ControlClick($Title, "", "Button2")
	EndIf
	
	If $CmdLine[0] > 1 And $CmdLine[2] <> 3 Then Exit
WEnd

Exit

Func CorrectName($NewText)
	$Names = StringReplace($NewText, ":", "_")
	$Names = StringReplace($Names, "\", "_")
	$Names = StringReplace($Names, "/", "_")
	$Names = StringReplace($Names, "?", "_")
	$Names = StringReplace($Names, "*", "_")
	$Names = StringReplace($Names, ">", "_")
	$Names = StringReplace($Names, "<", "_")
	$Names = StringReplace($Names, "|", "_")
	$Names = StringReplace($Names, "#", "_")
	$Names = StringReplace($Names, """", "_")
	While StringInStr($Names, "__") <> 0
		$Names = StringReplace($Names, "__", "_")
	WEnd
	Return StringLeft($Names, 128)
EndFunc   ;==>CorrectName
